# CfnFirewall

Use the firewall to provide stateful, managed, network firewall and intrusion detection and prevention filtering for your VPCs in Amazon VPC .

The firewall defines the configuration settings for an AWS Network Firewall firewall. The settings include the firewall policy, the subnets in your VPC to use for the firewall endpoints, and any tags that are attached to the firewall AWS resource.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnFirewall
Implements: IInspectable, ITaggable, IEnvironmentAware, IFirewallRef, IConstruct, IDependable

- CloudFormation: [`AWS::NetworkFirewall::Firewall`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-networkfirewall-firewall.html)
- Source: Generated code
- Type last changed: v2.275.0 · 26 Oct 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_networkfirewall as networkfirewall } from 'aws-cdk-lib';
const cfnFirewall = new networkfirewall.CfnFirewall(this, 'MyCfnFirewall', {
  firewallName: 'firewallName',
  firewallPolicyArn: 'firewallPolicyArn',

  // the properties below are optional
  availabilityZoneChangeProtection: false,
  availabilityZoneMappings: [{
    availabilityZone: 'availabilityZone',
  }],
  deleteProtection: false,
  description: 'description',
  enabledAnalysisTypes: ['enabledAnalysisTypes'],
  firewallPolicyChangeProtection: false,
  natGatewayMappings: [{
    natGatewayId: 'natGatewayId',
  }],
  noSourcePreservation: false,
  proxySettings: {
    listenerProperties: [{
      port: 123,
      type: 'type',
    }],
  },
  subnetChangeProtection: false,
  subnetMappings: [{
    subnetId: 'subnetId',

    // the properties below are optional
    ipAddressType: 'ipAddressType',
  }],
  tags: [{
    key: 'key',
    value: 'value',
  }],
  transitGatewayId: 'transitGatewayId',
  vpcEndpoint: {
    subnetMappings: [{
      subnetId: 'subnetId',

      // the properties below are optional
      ipAddressType: 'ipAddressType',
    }],
    vpcId: 'vpcId',
  },
  vpcId: 'vpcId',
});
```

## Initializer

```ts
new CfnFirewall(scope: Construct, id: string, props: CfnFirewallProps)
```

## Construct Props

- `availabilityZoneChangeProtection`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A setting indicating whether the firewall is protected against changes to its Availability Zone configuration.

  When set to `TRUE` , you must first disable this protection before adding or removing Availability Zones.

- `availabilityZoneMappings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.AvailabilityZoneMappingProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.AvailabilityZoneMappingProperty.html)[] — The Availability Zones where the firewall endpoints are created for a transit gateway-attached firewall.

  Each mapping specifies an Availability Zone where the firewall processes traffic.

- `deleteProtection`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A flag indicating whether it is possible to delete the firewall.

  A setting of `TRUE` indicates that the firewall is protected against deletion. Use this setting to protect against accidentally deleting a firewall that is in use. When you create a firewall, the operation initializes this flag to `TRUE` .

- `description`: string — A description of the firewall.

- `enabledAnalysisTypes`: string[] — An optional setting indicating the specific traffic analysis types to enable on the firewall.

- `firewallName`: string (required) — The descriptive name of the firewall.

  You can't change the name of a firewall after you create it.

- `firewallPolicyArn`: string | [IFirewallPolicyRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_networkfirewall.IFirewallPolicyRef.html) (required) — The Amazon Resource Name (ARN) of the firewall policy.

  The relationship of firewall to firewall policy is many to one. Each firewall requires one firewall policy association, and you can use the same firewall policy for multiple firewalls.

- `firewallPolicyChangeProtection`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A setting indicating whether the firewall is protected against a change to the firewall policy association.

  Use this setting to protect against accidentally modifying the firewall policy for a firewall that is in use. When you create a firewall, the operation initializes this setting to `TRUE` .

- `natGatewayMappings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.NatGatewayMappingProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.NatGatewayMappingProperty.html)[] — The NAT gateways that the firewall proxies egress traffic through when NoSourcePreservation is true.

- `noSourcePreservation`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether the firewall operates in proxy mode, where the source IP address of traffic is not preserved.

  When true, specify NatGatewayMappings and VpcEndpoint instead of the top-level VpcId and SubnetMappings. You can't change this setting after you create the firewall.

- `proxySettings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.ProxySettingsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.ProxySettingsProperty.html) — The proxy listener configuration for a proxy-mode (no source preservation) firewall.

- `subnetChangeProtection`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A setting indicating whether the firewall is protected against changes to the subnet associations.

  Use this setting to protect against accidentally modifying the subnet associations for a firewall that is in use. When you create a firewall, the operation initializes this setting to `TRUE` .

- `subnetMappings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.SubnetMappingProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.SubnetMappingProperty.html)[] — The primary public subnets that Network Firewall is using for the firewall.

  Network Firewall creates a firewall endpoint in each subnet. Create a subnet mapping for each Availability Zone where you want to use the firewall.

  These subnets are all defined for a single, primary VPC, and each must belong to a different Availability Zone. Each of these subnets establishes the availability of the firewall in its Availability Zone.

  In addition to these subnets, you can define other endpoints for the firewall in `VpcEndpointAssociation` resources. You can define these additional endpoints for any VPC, and for any of the Availability Zones where the firewall resource already has a subnet mapping. VPC endpoint associations give you the ability to protect multiple VPCs using a single firewall, and to define multiple firewall endpoints for a VPC in a single Availability Zone.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — An array of key-value pairs to apply to this resource.

  For more information, see [Tag](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-resource-tags.html) .

- `transitGatewayId`: string — The unique identifier of the transit gateway associated with this firewall.

  This field is only present for transit gateway-attached firewalls.

- `vpcEndpoint`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.VpcEndpointProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.VpcEndpointProperty.html) — The VPC and subnets for a proxy-mode firewall's endpoint.

  Provide this instead of the top-level VpcId and SubnetMappings when NoSourcePreservation is true.

- `vpcId`: string | [IVPCRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_ec2.IVPCRef.html) — The unique identifier of the VPC where the firewall is in use.

  You can't change the VPC of a firewall after you create the firewall.

## Properties

- `attrEndpointIds`: string[] — The unique IDs of the firewall endpoints for all of the subnets that you attached to the firewall.

  The subnets are not listed in any particular order. For example: `["us-west-2c:vpce-111122223333", "us-west-2a:vpce-987654321098", "us-west-2b:vpce-012345678901"]` .

- `attrFirewallArn`: string — The Amazon Resource Name (ARN) of the firewall.

- `attrFirewallId`: string — The name of the firewallresource.

- `attrNumberOfAssociations`: number — The number of VPC endpoint associations attached to the firewall.

- `attrTransitGatewayAttachmentId`: string — The unique identifier of the transit gateway attachment associated with this firewall.

  This field is only present for transit gateway-attached firewalls.

- `availabilityZoneChangeProtection`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A setting indicating whether the firewall is protected against changes to its Availability Zone configuration.

- `availabilityZoneMappings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.AvailabilityZoneMappingProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.AvailabilityZoneMappingProperty.html)[] — The Availability Zones where the firewall endpoints are created for a transit gateway-attached firewall.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `deleteProtection`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A flag indicating whether it is possible to delete the firewall.

- `description`: string — A description of the firewall.

- `enabledAnalysisTypes`: string[] — An optional setting indicating the specific traffic analysis types to enable on the firewall.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `firewallName`: string — The descriptive name of the firewall.

- `firewallPolicyArn`: string — The Amazon Resource Name (ARN) of the firewall policy.

- `firewallPolicyChangeProtection`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A setting indicating whether the firewall is protected against a change to the firewall policy association.

- `firewallRef`: [FirewallReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_networkfirewall.FirewallReference.html) — A reference to a Firewall resource.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `natGatewayMappings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.NatGatewayMappingProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.NatGatewayMappingProperty.html)[] — The NAT gateways that the firewall proxies egress traffic through when NoSourcePreservation is true.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `noSourcePreservation`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether the firewall operates in proxy mode, where the source IP address of traffic is not preserved.

- `proxySettings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.ProxySettingsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.ProxySettingsProperty.html) — The proxy listener configuration for a proxy-mode (no source preservation) firewall.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `subnetChangeProtection`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A setting indicating whether the firewall is protected against changes to the subnet associations.

- `subnetMappings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.SubnetMappingProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.SubnetMappingProperty.html)[] — The primary public subnets that Network Firewall is using for the firewall.

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — An array of key-value pairs to apply to this resource.

- `transitGatewayId`: string — The unique identifier of the transit gateway associated with this firewall.

- `vpcEndpoint`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFirewall.VpcEndpointProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_networkfirewall.CfnFirewall.VpcEndpointProperty.html) — The VPC and subnets for a proxy-mode firewall's endpoint.

- `vpcId`: string — The unique identifier of the VPC where the firewall is in use.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForFirewall(resource: IFirewallRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnFirewall(x: any): boolean` (static) — Checks whether the given object is a CfnFirewall.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
